;squares.asm
; by adok/hugi
; shrunk by boreal
;Assemble with: tasm; tlink /t
;This assumes it will be run under DOSBox rather than MS-DOS.

	.model	tiny
	.code
	.586
	org	100h
;ax=0, bx=0, cx=00FFh, dx=cs, si=0100h, di=-2, bp=09xx, sp=-2
;variables are initialized to all 0's by DOSBox here:
rec0	equ	0A0h
endData	equ	rec0 + 9*4

start:	push	0A000h
	pop	es
	mov	al, 13h 		;set 320x200x8 graphics
	int	10h

;Set palette to (at least) 11 shades from black to bright red. (ch=0)
	xchg	ax, si			;al:= 0; point to color register 0
	mov	dx, 03C9h
setpal: out	dx, al
	xchg	ax, bx			;get 0 from bx=0 and save al
	out	dx, al
	out	dx, al
	xchg	bx, ax
	add	al, 6
	loop	setpal

;bl = 0 = loop counter
main00: mov	si, offset rec0		;point to start of data
main10:	mov	dx, 03DAh		;wait for vertical blank off
vsync1: in	al, dx
	test	al, 08h
	jne	vsync1
vsync2: in	al, dx			;wait for vertical blank on
	test	al, 08h
	je	vsync2

;di:= X*20; range: 0..15*20 = 0..300
	lodsb				;get X; al:= ds:[si++]
	cbw				;ah:= 0
	imul	di, ax, 20
	lodsb				;get Y; al:= ds:[si++]
	imul	cx, ax, 6420

	xor	ax, ax			;al:= color = black = 0
	mov	dx, 20			;size in pixels

;Draw square(di = location, dx = pixel size, al = color)
drawsq:	add	di, cx
	push	di
	mov	bp, dx
draw10:	mov	cx, dx
	rep stosb			;es:[di++]:= al; cx--
	add	di, 320			;move to start of next scanline
	sub	di, dx
	dec	bp
	jne	draw10
	pop	di

	mov	al, [si]		;get size = color
	imul	dx, ax, 2		;dx:= al*2; (ah=0)
	mov	cl, 10			;di:= di + (10-size)*321
	sub	cl, al			;(ch=0)
	imul	cx, 321

	xor	bh, 1
	jne	drawSq
	inc	si

;al=size; ah=0; [si]=dir
	inc	ax			;size++ if dir=0
	sub	al, [si]		;if dir=2 then size--
	je	rev			;if size=0 or size=10 then
	cmp	al, 10
	jne	cont
rev:	xor	byte ptr [si], 2	;  reverse direction
cont:	mov	[si-1], al		;set new size

	inc	bl			;increment loop counter
	jne	next			;every 256 loops (ah=0)
	 int	1Ah			;  get system tick count into cx:dx
	 xchg	ax, dx
	 mov	ah, al			;  ah:= dl-5 & 7 = Y = 0..7
	 sub	ah, 5
	 and	ax, 070Fh		;  al:= dl   & F = X = 0..15
	 mov	[si-3], ax
next:
	inc	si			;point to next X
	cmp	si, offset endData
	jne	main10

	in	al, 60h			;loop if not Esc key
	dec	al
	jne	main00
	ret
	end	start
